/*
 * task.h X68k SX_SYSTEM ver 2.01 Copyright 1994 SHARP/First Class Technology
 */
#ifndef __TASK_H
#define __TASK_H

#ifndef __SXDEF2_H
#include <sxdef2.h>
#endif

#ifdef FORWORD
#define __PROTO_TYPE
#endif
#ifdef __STDC__
#define __PROTO_TYPE
#endif

typedef enum TSEventCode TSEventCode;	/* ^XN}CxgR[h	*/
typedef enum TaskState	TaskState;	/* ^XN̏			*/
typedef enum CMDSRscID	CMDSRscID;	/* CMDS\[X̂hc		*/

typedef struct Task	Task;		/* ^XNǗR[h		*/
typedef struct Builtin	Builtin;	/* rgCR}h`R[h */
typedef struct Cell	Cell;		/* ZR[h			*/
typedef struct Drag	Drag;		/* hbOR[h		*/
typedef struct Scrap	Scrap;		/* XNbvR[h		*/
typedef struct DrvInfo	DrvInfo;	/* hCu񃌃R[h		*/
typedef struct OpenFile	OpenFile;	/* I[vt@CǗR[h */
typedef struct IcKind	IcKind;		/* ACR`R[h		*/
typedef struct IcState	IcState;	/* ACRǗR[h		*/
/*
 *	^XN} (Task Man)
 */
#ifndef SXKERNEL
#define SXKERNEL	"sxkernel.x"	/* SXJ[l̃t@C	*/
#endif
#ifndef SXVER2
#define SXVER2		0x0201		/* \SXVXẽo[W */
#endif
#define TS_OWN		(-1)		/* ̃^XNhc		*/
#define TS_FINISH	0		/* hbO̐I		*/
#define TS_PUTBACK	(-1)		/* o[og͂Ԃ`ŏI */

enum TSEventCode {			/* ^XN}CxgR[h	*/
	STARTUP,			/* N̂߂̃^XNԒʐM	*/
	ENDTSK,				/* S^XN̏I		*/
	CLOSEALL,			/* SEBhẼN[Y	*/
	NOTICEEJECT,			/* fBXNCWFNg̗\	*/
	DISKEJECT,			/* fBXÑCWFNg		*/
	NOTICEFORMAT,			/* fBXNtH[}bg̗\	*/
	DISKFORMAT,			/* fBXÑtH[}bg	*/
	NOTICEDCOPY,			/* fBXNRs[̗\		*/
	DISKCOPY,			/* fBXÑRs[		*/
	DISKINSERT,			/* fBXN̑}܂͏Ԃ̕ω */
	REMOVEDIR,			/* fBNg̍폜		*/
	DELETEFILE,			/* t@C̍폜		*/
	DELETEVONAME,			/* {[̍폜		*/
	MOVEFILE,			/* t@C̈ړ		*/
	COPYFILE,			/* t@C̕		*/
	MAKEDIR,			/* fBNg̍쐬		*/
	CREATFILE,			/* t@C̍쐬		*/
	CREATEVONAME,			/* {[̍쐬		*/
	OPENFILE	=  20,		/* t@C̃I[v		*/
	CLOSEFILE,			/* t@C̃N[Y		*/
	CHMODFILE,			/* t@C̕ύX		*/
	CLOSEPATH	=  30,		/* w肵pX̃N[Y	*/
	SAVE,				/* ݂̏ԂZ[u		*/
	WINDOWSELECT,			/* EBhẼZNg		*/
	NOTICEENDTSK,			/* S^XNI̗\		*/
	TOSCRAP		=  50,		/* XNbvobt@ւ̃f[^] */
	EMPTYTRASH,			/* N[ĩtbV		*/
	CREATETSK	=  70,		/* ^XN̋N			*/
	EXITTSK,			/* ^XN̏I			*/
	DRAGNOW		=  80,		/* hbO			*/
	DRAGEND,			/* hbȌI		*/
	SETFONT		=  85,		/* tHg̐ݒ		*/
	CHANGEFONT,			/* tHgt@C̕ύX	*/
	CHANGERSC	=  90,		/* \[X̕ύX		*/
	DELETERSC,			/* \[X̍폜		*/
	REQLOADRSC	= 104,		/* \[X̃ւ̓ǂݍݗv */
	RESLOADRSC			/* \[X̃ւ̓ǂݍݗv
					   ΂G[̕ԑ		*/
};

enum TaskState {			/* ^XN̏			*/
	TS_EMPTY,			/* 폜ꂽ^XN		*/
	TS_ACTIVE,			/* ʏ퓮쒆			*/
	TS_COMMUNICATE,			/* ^XNԒʐMiԎ󂯂j*/
	TS_SENDMES,			/* ^XNԒʐMiԎ󂯂Ȃj*/
	TS_SLEEP,			/* VXe\			*/
	TS_STARTUP,			/* N			*/
	TS_LOAD,			/* [h		*/
	TS_EXIT				/* R[ḧɏI	*/
};

enum CMDSRscID {			/* CMDS\[X̂hc		*/
	CMDSDIR,			/* fBNg\		*/
	CMDSCHD,			/* hCugC		*/
	CMDSPINFO,			/* vZX			*/
	CMDSDINFO,			/* hCu			*/
	CMDSINFO,			/* t@C			*/
	CMDSCLO,			/* pX̃N[Y		*/
	CMDSREN,			/* t@C̕ύXEȂ	*/
	CMDSCLIP,			/* Nbv{[h		*/
	CMDSVDCP,			/* fBXNRs[		*/
	CMDSVFOR,			/* tH[}bg			*/
	CMDSCOPY,			/* t@C̃Rs[		*/
	CMDSCSHL,			/* R}h			*/
	CMDSHENW,			/* ZbgɋNt@C	*/
	CMDSTITL,			/* IɋNt@C	*/
	CMDSLDLB,			/* ׂẴ\[X̃[h	*/
	CMDSADJS,			/* fXNgbṽXN[	*/
	CMDSFALL,			/* fXNgbv̐		*/
	CMDSFILE	/* 17 */	/* t@CpX̊wK	*/
};

/* t@CtO */
#define TS_RDONLY	1		/* ǂݍݐp			*/
#define TS_HIDDEN	(1 << 1)	/* Bt@C			*/
#define TS_SYSTEM	(1 << 2)	/* VXet@C		*/
#define TS_VOLID	(1 << 3)	/* {[			*/
#define TS_SUBDIR	(1 << 4)	/* TufBNg		*/
#define TS_ARCH		(1 << 5)	/* ʏt@C			*/

/* ACetO */
#define TS_EJECT	(1 << 4)	/* CWFNg{^		*/
#define TS_QUEST	(1 << 5)	/* NGX`}[N		*/
#define TS_PROTECT	(1 << 6)	/* veNg}[N		*/

enum TSErrorCode {			/* ^XN}̃G[R[h	*/
	ER_ABORT	= -0x2002,	/* n[hEFAG[ɂA{[g */
	ER_OBJX,			/* PƎs̃t@C		*/
	ER_NOTHEAD,			/* ^XN}œ삵Ȃt@C */
	ER_NOTOBJECT,			/* st@Cł͂Ȃ		*/
	ER_NOTLOAD,			/* t@CI[vG[	*/
	ER_NOTPARA,			/* ɕsłȂt@C */
	ER_FILENOTFND	= -0x1fe1,	/* t@CtȂ	*/
	ER_SERCHBREAK,			/* t@Cfꂽ	*/
	ER_SERCHONEDRV,			/* PhCu		*/
	ER_DRVNOTREADY,			/* hCȕłĂȂ	*/
	ER_RSCROUTEERR	= -0x1fdb	/* ȃ\[Xnw肵	*/
};

struct Task {				/* ^XNǗR[h		*/
	char name[TS_NAMEMAX];		/* ^XN			*/
	LASCII command;			/* R}hC		*/
	short taskID;			/* ^XNhc			*/
	short parentID;			/* ẽ^XNhc		*/
	short stMode;			/* グ[h		*/
	long rscType;			/* \[X^Cv		*/
	short rscID;			/* \[Xhc			*/
	short state;			/* ݂̏			*/
	void *programPtr;		/* vOGAւ̃|C^	*/
	Handle programHdl;		/* vOGAւ̃nh	*/
	Handle dataHdl;			/* f[^GAւ̃nh	*/
	char *envPtr;			/* ւ̃|C^		*/
	long regKeep[18];		/* WX^Ҕ			*/
	short commSendID;		/* ŌɑM^XN̂hc	*/
	short commRecvID;		/* ݎ󂯂Ă^XNԒʐM
					   M^XN̂hc		*/
	long tickCount;			/* ÑVXe		*/
	Handle commonHdl;		/* RGAւ̃nh	*/
	long rsv1[3];			/* VXe\			*/
	long refCon;			/* [U[p[NGA	*/
	long rscChain;			/* \[Xn			*/
	short rsv2[16];			/* VXe\			*/
};

struct Builtin {			/* rgCR}h`R[h */
	short rscID;			/* \[XCODÊhc		*/
	char length;			/* R}h̒		*/
	char name[_VARLEN];		/* R}hiϒf[^j	*/
};

struct Cell {				/* ZR[h			*/
	unsigned long kind;		/* Zf[^̎ނ\S */
	long size;			/* Zf[^̃TCY		*/
	unsigned char data[_VARLEN];	/* Zf[^{́iϒf[^j*/
};

struct Drag {				/* hbOR[h		*/
	long size;			/* ZXg̃TCY		*/
	Handle cellList;		/* ZXgւ̃nh	*/
	short taskID;			/* ̃^XNhc		*/
	Point origen;			/* [JW̃ItZbg	*/
	BitImg *image;			/* C[Wf[^ւ̃|C^	*/
};

struct Scrap {				/* XNbvR[h		*/
	long size;			/* ZXg̃TCY		*/
	Handle cellList;		/* ZXgւ̃nh	*/
};

struct DrvInfo {			/* hCu񃌃R[h		*/
	unsigned char mediaByte;	/* fBAoCg		*/
	unsigned char unitno;		/* jbgԍ			*/
	short driveno;			/* hCuԍ			*/
};

struct OpenFile {			/* I[vt@CǗR[h */
	char name[TS_NAMEMAX];		/* t@C			*/
	short mode;			/* ANZX[h		*/
	short ID;			/* t@Cnh		*/
};

struct IcKind {				/* ACR`R[h		*/
	long type;			/* ACRp^[̃\[X^Cv */
	short ID;			/* ACRp^[̃\[Xhc */
	short attrib;			/* ACȒiVXegpj*/
	short mLDown;			/* NbN̏
					   iVXegpj		*/
	short menuID1;			/* EvX̃j[hc	*/
	short menuID2;			/* [SHIFT]{EvX̃j[hc */
	char nameLen;			/* t@C^V{̒	*/
	char name[_VARLEN];		/* t@C^V{(ϒf[^) */
/*	char execLen;			   st@C̒
	char exec[_VARLEN];		   st@Ciϒf[^j*/
/*	unsigned char paramLen;		   p[^̒
	char param[_VARLEN];		   p[^iϒf[^j*/
};

struct IcState {			/* ACRǗR[h		*/
	Rect bounds;			/* Ŝ͂ރN^O	*/
	char name[18 + 3];		/* t@C^V{		*/
	unsigned char attrib;		/* t@C̑		*/
	long opt1;			/* IvVPiVXegpj*/
	long opt2;			/* IvVQiVXegpj*/
	unsigned char mediaByte;	/* fBAoCg		*/
	unsigned char unitno;		/* jbgԍ			*/
	short iconID;			/* \[XICN#̂hc		*/
	char *path;			/* pXւ̃|C^		*/
	unsigned char flag;		/* ACetO		*/
	unsigned char drawMode;		/* \[hiVXegpj	*/
	unsigned char rsv[4];		/* VXe\			*/
};

#ifdef __PROTO_TYPE

Heap *TSInitTsk(void *, void *, const char *, int, int, int, Handle *);
int TSInitCrtM(void);
int TSTiniCrtM(int);
int TSFock(int, int, char *, const char *, const char *, long, int);
int TSFockB(int, BOOLEAN, const char *, const char *, const char *, char *);
int TSFockSItem(Handle);
int TSFockIcon(IcState *, int, BOOLEAN, char *, char *);
int TSEventAvail(int, TsEvent *);
int TSGetEvent(int, TsEvent *);
int TSPostEventTsk(long, long, int, BOOLEAN, BOOLEAN);
int TSGetTdb(Task *, int);
int TSSetTdb(Task *, int);
LPoint TSGetWindowPos(void);
int TSCommunicate(int, TsEvent *, int);
int TSGetID(void);
int TSMakeEvent(long, long, int, BOOLEAN, BOOLEAN, TsEvent *);
BOOLEAN TSGetStartMode(void);
void TSSetStartMode(int);
int TSOpen(const char *, int);
int TSClose(int);
int TSRmDirH(char **);
int TSCopyH(char **, char **);
int TSMkDirH(char **);
int TSMoveH(char **, char **);
int TSCreate(const char *, int);
int TSDeleteH(char **);
int TSTrash(char **, char **);
int TSFiles(void *, const char *, int);
int TSNFiles(void *, const char *, int);
int TSCopyP(const char *, const char *);
int TSDeleteP(const char *);
int TSRmDirP(const char *);
int TSMkDirP(const char *);
int TSMoveP(const char *, const char *);
int TSChMod(const char *, int);
long TSWhatFile(TsEvent *, const char *);
int TSDeleteVoname(const char *);
int TSCreateVoname(const char *);
long TSSearchFileND(const char *, char *, const char *);
int TSGetOpen(OpenFile ***);
int TSZeroDrag(void);
int TSPutDrag(long, Handle);
int TSGetDrag(Drag **);
int TSBeginDrag(LPoint);
int TSEndDrag(int);
int TSHideDrag(void);
int TSShowDrag(void);
int TSZeroScrap(void);
int TSPutScrap(long, Handle);
long TSGetScrap(Scrap **);
int TSSearchTrashpath(char **);
int TSSearchTrashfile(char **);
int TSEmptyTrash(void);
int TSSearchdpb(int, int);
int TSDrvctrl(int, int);
int TSDrvctrl2(int, int);
int SXCallWindM(Window *, TsEvent *);
int SXCallCtrlM(Window *, TsEvent *, Control **, Control **, Rect *, Control ***);
int SXInvalScBar(Window *);
int SXValidScBar(Window *);
int TSISRecToStr(IcState *, char *);
int TSCreateISFile(char **, IcState *);
BOOLEAN SXFileConnPath(const char *, const char *);
int SXFileInPath(const char *, const char *);
int SXFnamecmp(const char *, int, const char *, int);
long SXSearchFname(const char *, char **);
int SXVer(void);
int TSTakeParam(const _LASCII, Rect *, char *, int, char **, char **);
long TSFindTskn(const char *, int);
int TSDriveCheckAll(BOOLEAN);
int TSDriveCheck(int);
int TSISRecToExec(IcState *, char *, _LASCII);
BOOLEAN TSGetDtopMode(void);
void TSSetDtopMode(BOOLEAN);
int TSSearchOpen(char **, int, int, OpenFile **);
long TSFindOwn(void);
int TSCommunicateS(int, TsEvent *, int);
long TSSearchFile2(int, int, void *, const char *, char *, const char *);
long TSSearchFile(const char *, char *, const char *);
int SXStrCmp(const char *, const char *, int);
int TSCreateISBadge(IcState *, int, int);
int TSGetCMDS(int, char *);
int TSFockCM(int, BOOLEAN, int, const char *, const char *, char *);
int TSTiniTsk(void);
int TSPostEventTsk2(long, long, int, BOOLEAN, BOOLEAN, int);
int TSAnswer(TsEvent *);
int TSSendMes(int, TsEvent *);
BOOLEAN TSGetMes(TsEvent *, BOOLEAN);
Heap *TSInitTsk2(void *, void *, const char *, int, BOOLEAN, int, char *, Handle *);
int SXCallWindM2(Window *, TsEvent *, Rect *);
int TSBeginDrag2(LPoint, void *, long);
void *SXGetVector(int);
void *SXSetVector(int, void *);
long TSCellToStr(Handle, char *, long, char ***);
void SXLockFSX(void);
void SXUnlockFSX(void);
int TSFockMode(const char *, char *, long *);
int TSSetGraphMode(BOOLEAN, int);
long TSGetGraphMode(long *);
int SXGetDispRect(Rect *);
int SXSRAMVer(void);
void SXSRAMReset(void);
int SXSRAMCheck(void);
void TSAdjustRect(Rect *, Rect *, int);
int TSPostEventTsk3(long, long, int, int, int, int, long, long);
int TSAnswer2(long, long, int, int, int, int, long, long);
int TSErrDialogN(int, const char *);
long TSSearchFile3(int, int, const char *, char *, const char *, int (*)(const char *, long));
Handle TSResNew(void);
Handle TSResOpen(const char *);
int TSResClose(const char *);
int TSResSave(const char *);
int TSResRemove(void);
int TSResLoad(void);
int TSResDispose(void);
Handle TSCurResGet(void);
Handle TSLastResGet(void);
Handle TSCurResSet(Handle);
_Handle TSRscAdd(long, int, _Handle, long);
_Handle TSRscGet(long, int);
int TSRscRemove(long, int);
int TSTypeRemove(long);
int TSRscRelease(_Handle);
int TSRscDetach(_Handle);
int TSMaxIDGet(long);
Handle TSHdlToRsc(_Handle);
Handle TSResLinkGet(Handle);
long TSResRouteLink(int, long);
long TSResRouteGet(int);
_Handle TSRscGet2(long, int, long);
_Handle TSRscGet3(long, int);
int TSResRouteUnLink(void);
int TSMaxIDGet2(long, long);
Handle TSFind(_Handle, long *, long *);
Handle TSCurResGet2(long);
int TSMaxIDGet3(long);
int TSResFileGet(Handle, char *);
long TSResRouteFind(const char *, int, long);
int TSResTypeList(int *, long ***, Handle);
int TSResIDList(int *, short ***, Handle, long);
void (*TSSetAbort(void (*)(), long))();
Window *TSReferWM(int, Window *, Window *);
Control **TSReferCM(int, Window *);
Menu **TSReferMN(int);
Dialog *TSReferDM(int, Dialog *, Window *);

#undef __PROTO_TYPE
#else

Heap *TSInitTsk();
int TSInitCrtM();
int TSTiniCrtM();
int TSFock();
int TSFockB();
int TSFockSItem();
int TSFockIcon();
int TSEventAvail();
int TSGetEvent();
int TSPostEventTsk();
int TSGetTdb();
int TSSetTdb();
LPoint TSGetWindowPos();
int TSCommunicate();
int TSGetID();
int TSMakeEvent();
BOOLEAN TSGetStartMode();
void TSSetStartMode();
int TSOpen();
int TSClose();
int TSRmDirH();
int TSCopyH();
int TSMkDirH();
int TSMoveH();
int TSCreate();
int TSDeleteH();
int TSTrash();
int TSFiles();
int TSNFiles();
int TSCopyP());
int TSDeleteP());
int TSRmDirP();
int TSMkDirP();
int TSMoveP();
int TSChMod();
long TSWhatFile();
int TSDeleteVoname();
int TSCreateVoname();
long TSSearchFileND();
int TSGetOpen();
int TSZeroDrag();
int TSPutDrag();
int TSGetDrag());
int TSBeginDrag();
int TSEndDrag();
int TSHideDrag();
int TSShowDrag();
int TSZeroScrap();
int TSPutScrap();
long TSGetScrap();
int TSSearchTrashpath();
int TSSearchTrashfile();
int TSEmptyTrash();
int TSSearchdpb();
int TSDrvctrl();
int TSDrvctrl2();
int SXCallWindM();
int SXCallCtrlM();
int SXInvalScBar();
int SXValidScBar();
int TSISRecToStr();
int TSCreateISFile();
BOOLEAN SXFileConnPath();
int SXFileInPath();
int SXFnamecmp();
long SXSearchFname());
int SXVer();
int TSTakeParam();
long TSFindTskn();
int TSDriveCheckAll();
int TSDriveCheck();
int TSISRecToExec();
BOOLEAN TSGetDtopMode();
void TSSetDtopMode();
int TSSearchOpen();
long TSFindOwn();
int TSCommunicateS();
long TSSearchFile2();
long TSSearchFile();
int SXStrCmp();
int TSCreateISBadge();
int TSGetCMDS();
int TSFockCM();
int TSTiniTsk();
int TSPostEventTsk2();
int TSAnswer();
int TSSendMes();
BOOLEAN TSGetMes();
Heap *TSInitTsk2();
int SXCallWindM2();
int TSBeginDrag2();
void *SXGetVector();
void *SXSetVector();
long TSCellToStr();
void SXLockFSX();
void SXUnlockFSX();
int TSFockMode();
int TSSetGraphMode();
long TSGetGraphMode();
int SXGetDispRect();
int SXSRAMVer();
void SXSRAMReset();
int SXSRAMCheck();
void TSAdjustRect();
int TSPostEventTsk3();
int TSAnswer2();
int TSErrDialogN();
long TSSearchFile3();
Handle TSResNew();
Handle TSResOpen();
int TSResClose();
int TSResSave();
int TSResRemove();
int TSResLoad();
int TSResDispose();
Handle TSCurResGet();
Handle TSLastResGet();
Handle TSCurResSet();
_Handle TSRscAdd();
_Handle TSRscGet();
int TSRscRemove();
int TSTypeRemove();
int TSRscRelease();
int TSRscDetach();
int TSMaxIDGet();
Handle TSHdlToRsc();
Handle TSResLinkGet();
long TSResRouteLink();
long TSResRouteGet();
_Handle TSRscGet2());
_Handle TSRscGet3();
int TSResRouteUnLink();
int TSMaxIDGet2();
Handle TSFind();
Handle TSCurResGet2();
int TSMaxIDGet3();
int TSResFileGet();
long TSResRouteFind();
int TSResTypeList();
int TSResIDList();
void (*TSSetAbort())();
Window *TSReferWM();
Control **TSReferCM();
Menu **TSReferMN();
Dialog *TSReferDM();

#endif __PROTO_TYPE

#endif __TASK_H
